﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace MidiMan
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        MIDIControl myMidi;

        private void setupMidi()
        {
            try
            {
                myMidi = new MIDIControl(0);
            }
            catch
            {
                MessageBox.Show("Midi setup failed", "Midi Control");
                Application.Current.Shutdown();
            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            setupMidi();
        }

        private void note_MouseDown(object sender, MouseButtonEventArgs e)
        {
            myMidi.SendMIDIMessage(
                            0x90,  // midi command - note down on channel 0
                            60,    // note value – 60 represents middle C on the keyboard
                            100);  // note velocity – how hard the note was hit in the range 0 to 127
        }

        private void note_MouseUp(object sender, MouseButtonEventArgs e)
        {
            myMidi.SendMIDIMessage(
                            0x80,  // midi command - note up on channel 0
                            60,    // note value – 60 represents middle C on the keyboard
                            100);  // note velocity – how "hard" the note was released in the range 0 to 127
        }
    }
}
